// ******************************************
// XMLʈʒu񑀍NX
//
//@ŕo
// ******************************************
using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.IO;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;

using FormScreen.OutType;

namespace FormScreen.OutDAL
{
    public sealed class XmlOutDAL
    {
        public static string FileName = @"\Screen.XML";
        
        public static Hashtable ReadXMLFile()
        {
            Hashtable outData=new Hashtable();

            string path = Application.StartupPath.ToString() + FileName;
            if (File.Exists(path))
            {
                XmlTextReader reader = new XmlTextReader(path);
                ArrayList list = new ArrayList();
                XmlOutType buff = new XmlOutType();
                XmlOutType.xmlBuffPoint location = new XmlOutType.xmlBuffPoint();
                XmlOutType.xmlBuffSize size = new XmlOutType.xmlBuffSize();

                #region t@Cǂ
                try
                {
                    while (reader.Read())
                    {
                        if (reader.NodeType == XmlNodeType.Element)
                        {
                            string name = reader.Name;
                            if (name != null)
                            {
                                name = string.IsInterned(name);
                                if (name == "screen")
                                {
                                    buff = new XmlOutType();
                                    list.Add(buff);
                                }
                                else
                                {
                                    if (name == "screen_name")
                                    {
                                        buff.ScreenName = reader.ReadString();
                                        continue;
                                    }
                                    if (name == "location")
                                    {
                                        location = buff.Location;
                                        continue;
                                    }
                                    if (name == "size")
                                    {
                                        size = buff.Size;
                                        continue;
                                    }
                                    if (name == "auto_scroll_position")
                                    {
                                        location = buff.AutoScrollPosition;
                                        continue;
                                    }
                                    if (name == "x")
                                    {
                                        location.X = int.Parse(reader.ReadString());
                                        continue;
                                    }
                                    if (name == "y")
                                    {
                                        location.Y = int.Parse(reader.ReadString());
                                        continue;
                                    }
                                    if (name == "width")
                                    {
                                        size.Width = int.Parse(reader.ReadString());
                                        continue;
                                    }
                                    if (name == "height")
                                    {
                                        size.Height = int.Parse(reader.ReadString());
                                    }
                                }
                            }
                        }
                    }
                }
                catch (XmlException exception)
                {
                    MessageBox.Show("ʂ̏Ԃ𕜌ł܂łB\n" + exception.Message, "ݒt@Cǂݍ݃G[");

                    return null;
                }
                finally
                {
                    if (reader != null)
                    {
                        reader.Close();
                    }
                }

                #endregion

                foreach (XmlOutType buff2 in list)
                {
                    ScreenInfo info = new ScreenInfo();
                    info.ScreenName = buff2.ScreenName;
                    info.Location = new Point(buff2.Location.X, buff2.Location.Y);
                    info.Size = new Size(buff2.Size.Width, buff2.Size.Height);
                    info.AutoScrollPosition = new Point(buff2.AutoScrollPosition.X, buff2.AutoScrollPosition.Y);

                    outData.Add(info.ScreenName, info);
                }
            }

            return outData;
        }

        public static void WriteXMLFile(Hashtable i_data)
        {
            string path = Application.StartupPath.ToString() + FileName;
            File.Delete(path);
            XmlTextWriter writer = new XmlTextWriter(path, Encoding.UTF8);
            writer.Formatting=Formatting.Indented;
            writer.WriteStartDocument(true);
            writer.WriteStartElement("configuration");
            writer.WriteStartElement("ScreenInfo");
            writer.WriteStartElement("screens");
            if (i_data != null)
            {
                foreach (ScreenInfo info in i_data.Values)
                {
                    writer.WriteStartElement("screen");
                    writer.WriteElementString("screen_name", info.ScreenName.ToString());
                    writer.WriteStartElement("location");
                    writer.WriteElementString("x", info.Location.X.ToString());
                    writer.WriteElementString("y", info.Location.Y.ToString());
                    writer.WriteEndElement();
                    writer.WriteStartElement("size");
                    writer.WriteElementString("width", info.Size.Width.ToString());
                    writer.WriteElementString("height", info.Size.Height.ToString());
                    writer.WriteEndElement();
                    writer.WriteStartElement("auto_scroll_position");
                    writer.WriteElementString("x", info.AutoScrollPosition.X.ToString());
                    writer.WriteElementString("y", info.AutoScrollPosition.Y.ToString());
                    writer.WriteEndElement();
                    writer.WriteEndElement();
                }
            }
            writer.WriteEndElement();
            writer.WriteEndElement();
            writer.WriteEndElement();
            writer.Close();
        }
    }
}
